#define USE_MIC_PREFETCHES

#ifdef USE_MIC_PREFETCHES
#define PREFETCH(a, b) prefetch(a, b)
#else
#define PREFETCH(a, b)
#endif
__kernel void update(const float OMEGA, const int msizex,const int msizey,const int msizez, const int sizex,const int sizey,const int sizez,__global float* a1, __global float* a2,__global float* a3, __global float* a4, __global float* b1, __global float* b2, __global float* b3, __global float* c1,  __global float* c2, __global float* c3, __global float* wrk1, __global float* wrk2, __global float* bnd,  __global float* p)
{
// (x,y,z)-> (x+sizex*(y+sizey*z))
#define idxz(I,J,K) ((I)+msizex*((J)+msizey*(K)))

    int I=get_global_id(0); 
    int J=get_global_id(1); 
    int K=get_global_id(2); 
    const int sizex1=sizex-1;
    const int sizey1=sizey-1;
    const int sizez1=sizez-1;
#ifdef USE_MIC_PREFETCHES
PREFETCH (&p[idxz(I+1,J,K)],1);
PREFETCH (&p[idxz(I-1,J,K)],1);
PREFETCH (&a1[idxz(I+1,J,K)],1);
PREFETCH (&a1[idxz(I-1,J,K)],1);
PREFETCH (&a2[idxz(I+1,J,K)],1);
PREFETCH (&a2[idxz(I-1,J,K)],1);
PREFETCH (&a3[idxz(I+1,J,K)],1);
PREFETCH (&a3[idxz(I-1,J,K)],1);
PREFETCH (&b1[idxz(I+1,J,K)],1);
PREFETCH (&b1[idxz(I-1,J,K)],1);
PREFETCH (&b2[idxz(I+1,J,K)],1);
PREFETCH (&b2[idxz(I-1,J,K)],1);
PREFETCH (&b3[idxz(I+1,J,K)],1);
#endif
    if(I>=1 && I<sizex1 &&J>=1 && J<sizey1 &&K>=1 && K<sizez1) 
{
    float s0=a1[idxz(I,J,K)]*p[idxz(I+1,J,K)]+ a2[idxz(I,J,K)]*p[idxz(I,J+1,K)]+ a3[idxz(I,J,K)]*p[idxz(I,J,K+1)]+ b1[idxz(I,J,K)]*(p[idxz(I+1,J+1,K)]-p[idxz(I+1,J-1,K)]-p[idxz(I-1,J+1,K)]+p[idxz(I-1,J-1,K)])+ b2[idxz(I,J,K)]*(p[idxz(I,J+1,K+1)]-p[idxz(I,J-1,K+1)]-p[idxz(I,J+1,K-1)]+p[idxz(I,J-1,K-1)])+ b3[idxz(I,J,K)]*(p[idxz(I+1,J,K+1)]-p[idxz(I-1,J,K+1)]-p[idxz(I+1,J,K-1)]+p[idxz(I-1,J,K-1)])+ c1[idxz(I,J,K)]*p[idxz(I-1,J,K)]+ c2[idxz(I,J,K)]*p[idxz(I,J-1,K)]+ c3[idxz(I,J,K)]*p[idxz(I,J,K-1)]+wrk1[idxz(I,J,K)];
    float ss=(s0*a4[idxz(I,J,K)]-p[idxz(I,J,K)])*bnd[idxz(I,J,K)];
    wrk2[idxz(I,J,K)]=p[idxz(I,J,K)]+OMEGA*ss;
}
}
