#ifndef CFFT4_OPENCL_H
#define CFFT4_OPENCL_H

#include <sys/time.h>
#include <CL/cl.h>
#include "config.h"

int devType;

cl_int err;     // error code returned from api calls

size_t global;  // global domain size for our calculation
size_t local;   // local domain size for our calculation

cl_platform_id cpPlatform; // OpenCL platform
cl_device_id cdDevice;    // compute device id
cl_device_id *deviceID;    // compute device id
cl_uint      deviceCount;
cl_context context;        // compute context
cl_command_queue commands; // compute command queue
cl_program program;        // compute program
cl_kernel kernel;          // compute kernel
char * KernelSource;
cl_device_id oclGetDev(cl_context cxGPUContext, unsigned int nr);

//void tic(struct timeval &from);

//double toc(struct timeval &from);

void init_opencl(const int id);
void finish_opencl(void);

void cfft4_opencl( int is, int m,
                   double ur[], double ui[],
                   double xr[], double xi[],
                   double wr[], double wi[],
                   double *time_kernel, double *time_copy);

char *print_cl_errstring(cl_int err);
#endif
