#define BLOCK_SIZE 16
__kernel void mat_mul(
 const int wA, const int wB, const int hA,
 __global float *A, __global float *B, __global float *C)
{
    // Block index
    int tx = get_local_id(0);
    int ty = get_local_id(1);
    int bx = get_group_id(0);
    int by = get_group_id(1);
 
    // Index of the first sub-matrix of A processed 
    // by the block
//Coalesced
    int indexA=by*BLOCK_SIZE*wA+ty*wA;
    int indexB=bx*BLOCK_SIZE+tx;
 
    float Csub=0.0f;
    // Loop over all the sub-matrices of A and B
    // required to compute the block sub-matrix
    for (int m =0;m<wA;m++)
    {
        Csub+= A[indexA]*B[indexB];
	indexA++;
	indexB+=wB;
    }
    // Write the block sub-matrix to device memory;
    // each thread writes one element
    int indexC=wB*BLOCK_SIZE*by+BLOCK_SIZE*bx+wB*ty+tx;
    C[indexC] = Csub;
}

